git-bisect.shon commit bisect--helper: `bisect_next_check` shell function in C (129a6cf)
   1#!/bin/sh
   2
   3USAGE='[help|start|bad|good|new|old|terms|skip|next|reset|visualize|view|replay|log|run]'
   4LONG_USAGE='git bisect help
   5        print this long help message.
   6git bisect start [--term-{old,good}=<term> --term-{new,bad}=<term>]
   7                 [--no-checkout] [<bad> [<good>...]] [--] [<pathspec>...]
   8        reset bisect state and start bisection.
   9git bisect (bad|new) [<rev>]
  10        mark <rev> a known-bad revision/
  11                a revision after change in a given property.
  12git bisect (good|old) [<rev>...]
  13        mark <rev>... known-good revisions/
  14                revisions before change in a given property.
  15git bisect terms [--term-good | --term-bad]
  16        show the terms used for old and new commits (default: bad, good)
  17git bisect skip [(<rev>|<range>)...]
  18        mark <rev>... untestable revisions.
  19git bisect next
  20        find next bisection to test and check it out.
  21git bisect reset [<commit>]
  22        finish bisection search and go back to commit.
  23git bisect (visualize|view)
  24        show bisect status in gitk.
  25git bisect replay <logfile>
  26        replay bisection log.
  27git bisect log
  28        show bisect log.
  29git bisect run <cmd>...
  30        use <cmd>... to automatically bisect.
  31
  32Please use "git help bisect" to get the full man page.'
  33
  34OPTIONS_SPEC=
  35. git-sh-setup
  36
  37_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  38_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
  39TERM_BAD=bad
  40TERM_GOOD=good
  41
  42bisect_head()
  43{
  44        if test -f "$GIT_DIR/BISECT_HEAD"
  45        then
  46                echo BISECT_HEAD
  47        else
  48                echo HEAD
  49        fi
  50}
  51
  52bisect_autostart() {
  53        test -s "$GIT_DIR/BISECT_START" || {
  54                gettextln "You need to start by \"git bisect start\"" >&2
  55                if test -t 0
  56                then
  57                        # TRANSLATORS: Make sure to include [Y] and [n] in your
  58                        # translation. The program will only accept English input
  59                        # at this point.
  60                        gettext "Do you want me to do it for you [Y/n]? " >&2
  61                        read yesno
  62                        case "$yesno" in
  63                        [Nn]*)
  64                                exit ;;
  65                        esac
  66                        bisect_start
  67                else
  68                        exit 1
  69                fi
  70        }
  71}
  72
  73bisect_start() {
  74        #
  75        # Check for one bad and then some good revisions.
  76        #
  77        has_double_dash=0
  78        for arg; do
  79                case "$arg" in --) has_double_dash=1; break ;; esac
  80        done
  81        orig_args=$(git rev-parse --sq-quote "$@")
  82        bad_seen=0
  83        eval=''
  84        must_write_terms=0
  85        revs=''
  86        if test "z$(git rev-parse --is-bare-repository)" != zfalse
  87        then
  88                mode=--no-checkout
  89        else
  90                mode=''
  91        fi
  92        while [ $# -gt 0 ]; do
  93                arg="$1"
  94                case "$arg" in
  95                --)
  96                        shift
  97                        break
  98                ;;
  99                --no-checkout)
 100                        mode=--no-checkout
 101                        shift ;;
 102                --term-good|--term-old)
 103                        shift
 104                        must_write_terms=1
 105                        TERM_GOOD=$1
 106                        shift ;;
 107                --term-good=*|--term-old=*)
 108                        must_write_terms=1
 109                        TERM_GOOD=${1#*=}
 110                        shift ;;
 111                --term-bad|--term-new)
 112                        shift
 113                        must_write_terms=1
 114                        TERM_BAD=$1
 115                        shift ;;
 116                --term-bad=*|--term-new=*)
 117                        must_write_terms=1
 118                        TERM_BAD=${1#*=}
 119                        shift ;;
 120                --*)
 121                        die "$(eval_gettext "unrecognised option: '\$arg'")" ;;
 122                *)
 123                        rev=$(git rev-parse -q --verify "$arg^{commit}") || {
 124                                test $has_double_dash -eq 1 &&
 125                                die "$(eval_gettext "'\$arg' does not appear to be a valid revision")"
 126                                break
 127                        }
 128                        revs="$revs $rev"
 129                        shift
 130                        ;;
 131                esac
 132        done
 133
 134        for rev in $revs
 135        do
 136                # The user ran "git bisect start <sha1>
 137                # <sha1>", hence did not explicitly specify
 138                # the terms, but we are already starting to
 139                # set references named with the default terms,
 140                # and won't be able to change afterwards.
 141                must_write_terms=1
 142
 143                case $bad_seen in
 144                0) state=$TERM_BAD ; bad_seen=1 ;;
 145                *) state=$TERM_GOOD ;;
 146                esac
 147                eval="$eval git bisect--helper --bisect-write '$state' '$rev' '$TERM_GOOD' '$TERM_BAD' 'nolog' &&"
 148        done
 149        #
 150        # Verify HEAD.
 151        #
 152        head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
 153        head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
 154        die "$(gettext "Bad HEAD - I need a HEAD")"
 155
 156        #
 157        # Check if we are bisecting.
 158        #
 159        start_head=''
 160        if test -s "$GIT_DIR/BISECT_START"
 161        then
 162                # Reset to the rev from where we started.
 163                start_head=$(cat "$GIT_DIR/BISECT_START")
 164                if test "z$mode" != "z--no-checkout"
 165                then
 166                        git checkout "$start_head" -- ||
 167                        die "$(eval_gettext "Checking out '\$start_head' failed. Try 'git bisect reset <valid-branch>'.")"
 168                fi
 169        else
 170                # Get rev from where we start.
 171                case "$head" in
 172                refs/heads/*|$_x40)
 173                        # This error message should only be triggered by
 174                        # cogito usage, and cogito users should understand
 175                        # it relates to cg-seek.
 176                        [ -s "$GIT_DIR/head-name" ] &&
 177                                die "$(gettext "won't bisect on cg-seek'ed tree")"
 178                        start_head="${head#refs/heads/}"
 179                        ;;
 180                *)
 181                        die "$(gettext "Bad HEAD - strange symbolic ref")"
 182                        ;;
 183                esac
 184        fi
 185
 186        #
 187        # Get rid of any old bisect state.
 188        #
 189        git bisect--helper --bisect-clean-state || exit
 190
 191        #
 192        # Change state.
 193        # In case of mistaken revs or checkout error, or signals received,
 194        # "bisect_auto_next" below may exit or misbehave.
 195        # We have to trap this to be able to clean up using
 196        # "bisect_clean_state".
 197        #
 198        trap 'git bisect--helper --bisect-clean-state' 0
 199        trap 'exit 255' 1 2 3 15
 200
 201        #
 202        # Write new start state.
 203        #
 204        echo "$start_head" >"$GIT_DIR/BISECT_START" && {
 205                test "z$mode" != "z--no-checkout" ||
 206                git update-ref --no-deref BISECT_HEAD "$start_head"
 207        } &&
 208        git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
 209        eval "$eval true" &&
 210        if test $must_write_terms -eq 1
 211        then
 212                git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
 213        fi &&
 214        echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
 215        #
 216        # Check if we can proceed to the next bisect state.
 217        #
 218        bisect_auto_next
 219
 220        trap '-' 0
 221}
 222
 223bisect_skip() {
 224        all=''
 225        for arg in "$@"
 226        do
 227                case "$arg" in
 228                *..*)
 229                        revs=$(git rev-list "$arg") || die "$(eval_gettext "Bad rev input: \$arg")" ;;
 230                *)
 231                        revs=$(git rev-parse --sq-quote "$arg") ;;
 232                esac
 233                all="$all $revs"
 234        done
 235        eval bisect_state 'skip' $all
 236}
 237
 238bisect_state() {
 239        bisect_autostart
 240        state=$1
 241        git bisect--helper --check-and-set-terms $state $TERM_GOOD $TERM_BAD || exit
 242        get_terms
 243        case "$#,$state" in
 244        0,*)
 245                die "Please call 'bisect_state' with at least one argument." ;;
 246        1,"$TERM_BAD"|1,"$TERM_GOOD"|1,skip)
 247                bisected_head=$(bisect_head)
 248                rev=$(git rev-parse --verify "$bisected_head") ||
 249                        die "$(eval_gettext "Bad rev input: \$bisected_head")"
 250                git bisect--helper --bisect-write "$state" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit
 251                git bisect--helper --check-expected-revs "$rev" ;;
 252        2,"$TERM_BAD"|*,"$TERM_GOOD"|*,skip)
 253                shift
 254                hash_list=''
 255                for rev in "$@"
 256                do
 257                        sha=$(git rev-parse --verify "$rev^{commit}") ||
 258                                die "$(eval_gettext "Bad rev input: \$rev")"
 259                        hash_list="$hash_list $sha"
 260                done
 261                for rev in $hash_list
 262                do
 263                        git bisect--helper --bisect-write "$state" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit
 264                done
 265                git bisect--helper --check-expected-revs $hash_list ;;
 266        *,"$TERM_BAD")
 267                die "$(eval_gettext "'git bisect \$TERM_BAD' can take only one argument.")" ;;
 268        *)
 269                usage ;;
 270        esac
 271        bisect_auto_next
 272}
 273
 274bisect_auto_next() {
 275        git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD && bisect_next || :
 276}
 277
 278bisect_next() {
 279        case "$#" in 0) ;; *) usage ;; esac
 280        bisect_autostart
 281        git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD $TERM_GOOD|| exit
 282
 283        # Perform all bisection computation, display and checkout
 284        git bisect--helper --next-all $(test -f "$GIT_DIR/BISECT_HEAD" && echo --no-checkout)
 285        res=$?
 286
 287        # Check if we should exit because bisection is finished
 288        if test $res -eq 10
 289        then
 290                bad_rev=$(git show-ref --hash --verify refs/bisect/$TERM_BAD)
 291                bad_commit=$(git show-branch $bad_rev)
 292                echo "# first $TERM_BAD commit: $bad_commit" >>"$GIT_DIR/BISECT_LOG"
 293                exit 0
 294        elif test $res -eq 2
 295        then
 296                echo "# only skipped commits left to test" >>"$GIT_DIR/BISECT_LOG"
 297                good_revs=$(git for-each-ref --format="%(objectname)" "refs/bisect/$TERM_GOOD-*")
 298                for skipped in $(git rev-list refs/bisect/$TERM_BAD --not $good_revs)
 299                do
 300                        skipped_commit=$(git show-branch $skipped)
 301                        echo "# possible first $TERM_BAD commit: $skipped_commit" >>"$GIT_DIR/BISECT_LOG"
 302                done
 303                exit $res
 304        fi
 305
 306        # Check for an error in the bisection process
 307        test $res -ne 0 && exit $res
 308
 309        return 0
 310}
 311
 312bisect_visualize() {
 313        git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
 314
 315        if test $# = 0
 316        then
 317                if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
 318                        type gitk >/dev/null 2>&1
 319                then
 320                        set gitk
 321                else
 322                        set git log
 323                fi
 324        else
 325                case "$1" in
 326                git*|tig) ;;
 327                -*)     set git log "$@" ;;
 328                *)      set git "$@" ;;
 329                esac
 330        fi
 331
 332        eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
 333}
 334
 335bisect_replay () {
 336        file="$1"
 337        test "$#" -eq 1 || die "$(gettext "No logfile given")"
 338        test -r "$file" || die "$(eval_gettext "cannot read \$file for replaying")"
 339        git bisect--helper --bisect-reset || exit
 340        while read git bisect command rev
 341        do
 342                test "$git $bisect" = "git bisect" || test "$git" = "git-bisect" || continue
 343                if test "$git" = "git-bisect"
 344                then
 345                        rev="$command"
 346                        command="$bisect"
 347                fi
 348                get_terms
 349                git bisect--helper --check-and-set-terms "$command" "$TERM_GOOD" "$TERM_BAD" || exit
 350                get_terms
 351                case "$command" in
 352                start)
 353                        cmd="bisect_start $rev"
 354                        eval "$cmd" ;;
 355                "$TERM_GOOD"|"$TERM_BAD"|skip)
 356                        git bisect--helper --bisect-write "$command" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit;;
 357                terms)
 358                        bisect_terms $rev ;;
 359                *)
 360                        die "$(gettext "?? what are you talking about?")" ;;
 361                esac
 362        done <"$file"
 363        bisect_auto_next
 364}
 365
 366bisect_run () {
 367        git bisect--helper --bisect-next-check $TERM_GOOD $TERM_BAD fail || exit
 368
 369        test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
 370
 371        while true
 372        do
 373                command="$@"
 374                eval_gettextln "running \$command"
 375                "$@"
 376                res=$?
 377
 378                # Check for really bad run error.
 379                if [ $res -lt 0 -o $res -ge 128 ]
 380                then
 381                        eval_gettextln "bisect run failed:
 382exit code \$res from '\$command' is < 0 or >= 128" >&2
 383                        exit $res
 384                fi
 385
 386                # Find current state depending on run success or failure.
 387                # A special exit code of 125 means cannot test.
 388                if [ $res -eq 125 ]
 389                then
 390                        state='skip'
 391                elif [ $res -gt 0 ]
 392                then
 393                        state="$TERM_BAD"
 394                else
 395                        state="$TERM_GOOD"
 396                fi
 397
 398                # We have to use a subshell because "bisect_state" can exit.
 399                ( bisect_state $state >"$GIT_DIR/BISECT_RUN" )
 400                res=$?
 401
 402                cat "$GIT_DIR/BISECT_RUN"
 403
 404                if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
 405                        >/dev/null
 406                then
 407                        gettextln "bisect run cannot continue any more" >&2
 408                        exit $res
 409                fi
 410
 411                if [ $res -ne 0 ]
 412                then
 413                        eval_gettextln "bisect run failed:
 414'bisect_state \$state' exited with error code \$res" >&2
 415                        exit $res
 416                fi
 417
 418                if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
 419                then
 420                        gettextln "bisect run success"
 421                        exit 0;
 422                fi
 423
 424        done
 425}
 426
 427bisect_log () {
 428        test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
 429        cat "$GIT_DIR/BISECT_LOG"
 430}
 431
 432get_terms () {
 433        if test -s "$GIT_DIR/BISECT_TERMS"
 434        then
 435                {
 436                read TERM_BAD
 437                read TERM_GOOD
 438                } <"$GIT_DIR/BISECT_TERMS"
 439        fi
 440}
 441
 442bisect_terms () {
 443        get_terms
 444        if ! test -s "$GIT_DIR/BISECT_TERMS"
 445        then
 446                die "$(gettext "no terms defined")"
 447        fi
 448        case "$#" in
 449        0)
 450                gettextln "Your current terms are $TERM_GOOD for the old state
 451and $TERM_BAD for the new state."
 452                ;;
 453        1)
 454                arg=$1
 455                case "$arg" in
 456                        --term-good|--term-old)
 457                                printf '%s\n' "$TERM_GOOD"
 458                                ;;
 459                        --term-bad|--term-new)
 460                                printf '%s\n' "$TERM_BAD"
 461                                ;;
 462                        *)
 463                                die "$(eval_gettext "invalid argument \$arg for 'git bisect terms'.
 464Supported options are: --term-good|--term-old and --term-bad|--term-new.")"
 465                                ;;
 466                esac
 467                ;;
 468        *)
 469                usage ;;
 470        esac
 471}
 472
 473case "$#" in
 4740)
 475        usage ;;
 476*)
 477        cmd="$1"
 478        get_terms
 479        shift
 480        case "$cmd" in
 481        help)
 482                git bisect -h ;;
 483        start)
 484                bisect_start "$@" ;;
 485        bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD")
 486                bisect_state "$cmd" "$@" ;;
 487        skip)
 488                bisect_skip "$@" ;;
 489        next)
 490                # Not sure we want "next" at the UI level anymore.
 491                bisect_next "$@" ;;
 492        visualize|view)
 493                bisect_visualize "$@" ;;
 494        reset)
 495                git bisect--helper --bisect-reset "$@" ;;
 496        replay)
 497                bisect_replay "$@" ;;
 498        log)
 499                bisect_log ;;
 500        run)
 501                bisect_run "$@" ;;
 502        terms)
 503                bisect_terms "$@" ;;
 504        *)
 505                usage ;;
 506        esac
 507esac